DWARF_ADD_EXPR_ADDR(3) | Library Functions Manual | DWARF_ADD_EXPR_ADDR(3)

# NAME

`dwarf_add_expr_addr`, `dwarf_add_expr_addr_b` — add a DW_OP_addr location expression

# LIBRARY

DWARF Access Library (libdwarf, -ldwarf)

# SYNOPSIS

`#include <libdwarf.h>`

Dwarf_Unsigned
`dwarf_add_expr_addr`(Dwarf_P_Expr expr, Dwarf_Unsigned address, Dwarf_Signed sym_index, Dwarf_Error *err);

Dwarf_Unsigned
`dwarf_add_expr_addr_b`(Dwarf_P_Expr expr, Dwarf_Unsigned address, Dwarf_Unsigned sym_index, Dwarf_Error *err);

# DESCRIPTION

Function `dwarf_add_expr_addr_b`() adds a `DW_OP_addr` location expression to the location expression descriptor referenced by argument expr.

Argument expr should reference a location expression descriptor allocated using the function dwarf_new_expr(3).

Argument address specifies the operand, a relocatable address value.

Argument sym_index specifies the ELF symbol index of the symbol to be used for relocation.

If argument err is not `NULL`, it will be used to store error information in case of an error.

Function `dwarf_add_expr_addr`() is deprecated. It is similar to function `dwarf_add_expr_addr_b`() except that it cannot handle all possible symbol index values.

# RETURN VALUES

On success, these functions return the size in bytes of the location expression byte stream generated. In case of an error, these functions return `DW_DLV_NOCOUNT` and set the argument err.

# ERRORS

These functions can fail with:

[`DW_DLE_ARGUMENT`]
  Argument expr was `NULL`.
[`DW_DLE_MEMORY`]
  An out of memory condition was encountered during the execution of the function.

# SEE ALSO

dwarf(3), dwarf_add_AT_location_expr(3), dwarf_add_expr_gen(3), dwarf_expr_current_offset(3), dwarf_expr_into_block(3), dwarf_new_expr(3)

September 9, 2011 | NetBSD 11.0